{ͻ}
{   Windows style functions for working with INI files. Format of INI  }
{                   files is similar to Windows' one.                  }
{                                                                      }
{         Copyright Alexander Rublinetsky (2:461/45.101@fidonet)       }
{                         FREEWARE,  "AS IS"                           }
{ͼ}
unit IniFiles;
interface
uses Dos;

function GetProfileInt( const section:string;  const entry:string;
                     default:integer;  const filename:PathStr):integer;
function GetProfileString( const section:string;  const entry:string;
                      const default:string;  const filename:PathStr):string;
{WriteProfileString creates file if it is not exists. Returns TRUE if succesful}
function WriteProfileString( const section:string;  const entry:string;
                      const value:string;  const filename:PathStr):boolean;

implementation
uses cases;
const flag:(f_NOFILE,f_SE,f_S0,f_00)=f_NOFILE;
{------------------------------------------------------------------------}
procedure DelSpaces(var st:string);
var l:byte;
begin
    while (Length(st)>=0) and (st[1]=' ') do Delete(st,1,1);  {head}
    l:=Length(st);
    while (l>=0) and (st[l]=' ') do begin                     {tail}
       Delete(st,l,1);
       l:=Length(st);
    end;
end;
{------------------------------------------------------------------------}
function NextSection(var tf:text):string;
var st:string;
    b1,b2:byte;
begin
     repeat
        repeat
           readln(tf,st);
           b1:=Pos('[',st);
        until eof(tf) or (b1>0);
        if eof(tf) then begin
           NextSection:='';
           Exit;
        end;
        if Pos(';',Copy(st,1,b1))>0 then begin
           b2:=0;
           Continue; {it was comment}
        end;
        b2:=Pos(']',st);
      until b2>b1+1;
      NextSection:=Copy(st,b1+1,b2-b1-1);
end;
{------------------------------------------------------------------------}
function NextEntry(var tf:text; var ent:string):string;
var st:string;
    b:byte;
begin
      repeat
        readln(tf,st);
        while (st='') and (not eof(tf)) do readln(tf,st);
        ent:='';
        b:=1;
        while (b<=Length(st)) and (st[b]<>';') and
              (st[b]<>'=') and (st[b]<>'[') do begin
           ent:=ent+st[b];
           inc(b);
        end;
        if st[b]='[' then begin
           NextEntry:='';
           Exit;
        end;
        DelSpaces(ent);
     until eof(tf) or (ent<>'');
     NextEntry:=ent;
     ent:='';
     if st[b]<>';' then inc(b);
     while (b<=Length(st)) and (st[b]<>';') do begin
        ent:=ent+st[b];
        inc(b);
     end;
     DelSpaces(ent);
end;
{------------------------------------------------------------------------}
function GetProfileInt( const section:string;  const entry:string;
                     default:integer;  const filename:PathStr):integer;
var st,
    defst  : string[20];
    int,res  : integer;
begin
     str(default,defst);
     st:=GetProfileString(section,entry,defst,filename);
     val(st,int,res);
     if res=0 then GetProfileInt:=int
              else GetProfileInt:=default;
end;
{------------------------------------------------------------------------}
function GetProfileString( const section:string;  const entry:string;
                      const default:string;  const filename:PathStr):string;
var f:text;
    en,se,s:string;
begin
     Assign(f,filename);
     {$I-} reset(f); {$I+}
     if IOResult<>0 then begin
        GetProfileString:=default;
        flag:=f_NOFILE;
        Exit;
     end;
     se:=section;
     en:=entry;
     UpCaseStr(se); DelSpaces(se);
     UpCaseStr(en); DelSpaces(en);
     repeat
        s:=NextSection(f);
        UpCaseStr(s);
        DelSpaces(s);
     until (s='') or (s=se);
     if s='' then begin
        GetProfileString:=default;
        Close(f);
        flag:=f_00;
        Exit;
     end;
     repeat
        s:=NextEntry(f,se);
        UpCaseStr(s);
        DelSpaces(s)
     until (s='') or (s=en);
     if s='' then begin
        GetProfileString:=default;
        Close(f);
        flag:=f_S0;
        Exit;
     end;
     GetProfileString:=se;
     Close(f);
     flag:=f_SE;
end;
{------------------------------------------------------------------------}
function WriteProfileString(const section:string; const entry:string;
                     const value:string; const filename:PathStr):boolean;
var f,f1:text;
    s,se,en:string;
    b:byte;
begin
     WriteProfileString:=TRUE;

     GetProfileString(section,entry,'%',filename);   { set the internal flag}

     Assign(f,filename);
     case flag of
       f_NOFILE: begin          { create new INI file }
                   {$I-}rewrite(f);{$I+}
                   if IOResult<>0 then begin
                      WriteProfileString:=FALSE;
                      Exit;
                   end;
                   writeln(f);
                   writeln(f,'[ ',section,' ]');
                   writeln(f,entry,' = ',value);
                   close(f);
                 end;
       f_00:    begin           { section [-], entry [-] }
                   append(f);
                   writeln(f);
                   writeln(f,'[ ',section,' ]');
                   writeln(f,entry,' = ',value);
                   close(f);
                end;
       f_S0:    begin           { section [+], entry [-] }
                   se:=section;
                   DelSpaces(se);
                   UpCaseStr(se);
                   reset(f);
                   assign(f1,'_$_$_$_.$$$');
                   rewrite(f1);
                   repeat
                     readln(f,s);
                     writeln(f1,s);
                     UpCaseStr(s); DelSpaces(s);
                   until (Pos(se,s)>0) and (Pos('[',s)>0) and (Pos(']',s)>0);
                   writeln(f1,entry,' = ',value);
                   while not eof(f) do begin
                      readln(f,s);
                      writeln(f1,s);
                   end;
                   close(f); close(f1);
                   erase(f); rename(f1,filename);
                end;
       f_SE:    begin           { section [+], entry [+] }
                   se:=section;
                   en:=entry;
                   DelSpaces(se); UpCaseStr(se);
                   DelSpaces(en); UpCaseStr(en);
                   reset(f);
                   assign(f1,'_$_$_$_.$$$');
                   rewrite(f1);
                   repeat
                     readln(f,s);
                     writeln(f1,s);
                     UpCaseStr(s); DelSpaces(s);
                   until (Pos(se,s)>0) and (Pos('[',s)>0) and (Pos(']',s)>0);
                   readln(f,s);
                   se:=s;
                   UpCaseStr(se); DelSpaces(se);
                   while (Pos(en,se)=0) or (Pos('=',se)=0) do begin
                     writeln(f1,s);
                     readln(f,s);
                     se:=s;
                     UpCaseStr(se); DelSpaces(se);
                   end;
                   b:=Pos(';',s);
                   write(f1,entry,' = ',value,' ');
                   if b>0 then writeln(f1,' ;',Copy(s,b+1,Length(s)-b))
                          else writeln(f1);
                   while not eof(f) do begin
                      readln(f,s);
                      writeln(f1,s);
                   end;
                   close(f); close(f1);
                   erase(f); rename(f1,filename);
                end;
     end;
end;
{------------------------------------------------------------------------}
end.
